//audio
datablock AudioProfile(JRflReloadSound)
{
   filename    = "./JRReload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(JRflFireSound)
{
   filename    = "./JRFire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(JRflImpactSound)
{
   filename    = "./JRImpact.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(JRflShellDebris)
{
	shapeFile = "./JRSExpel.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//emitter
datablock ParticleData(JRflSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.5";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(JRflSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "JRflSmokeParticle";
};

datablock ParticleData(JRflTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.085;
	constantAcceleration	= 0.0;
	lifetimeMS		= 4000;
	lifetimeVarianceMS	= 1000;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0.2 0.2 0.2 0.6";
	colors[1]	= "0.0 0.0 0.0 0.0";
	sizes[0]	= 0.4;
	sizes[1]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(JRflTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0;
   velocityVariance = 0.50;

   ejectionOffset = 0.0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = JRflTrailParticle;

   useEmitterColors = true;
   uiName = "Justice Rifle Trail";
};

datablock ParticleData(JRflExplosionParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 90.0;
	spinRandomMin		= -120.0;
	spinRandomMax		= 120.0;
	colors[0]     = "0.95 0.95 0.5 0.9";
	colors[1]     = "0.85 0.65 0.3 0.7";
	colors[2]     = "0.25 0.25 0.1 0.0";
	sizes[0]      = 1.0;
	sizes[1]      = 0.875;
	sizes[2]      = 0.0;
	times[0]      = 0.0;
	times[1]      = 0.3;
	times[2]      = 1.0;
};
datablock ParticleEmitterData(JRflExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0;
   thetaMin         = 80;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "JrflExplosionParticle";

   useEmitterColors = true;
   uiName = "Justice Rifle Explosion";
};
datablock ParticleData(JRflExplosionDustParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.11 0.105 0.1 0.2";
	colors[1]     = "0.105 0.1025 0.5 0.0";
	sizes[0]      = 1.85;
	sizes[1]      = 0.0;
};
datablock ParticleEmitterData(JRflExplosionDustEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 0.6;
   ejectionOffset   = 0.0;
   thetaMin         = 80;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "JrflExplosionDustParticle";

   useEmitterColors = true;
   uiName = "Justice Rifle Dust Explosion";
};
datablock ExplosionData(JRflExplosion)
{
   //explosionShape = "";
   soundProfile = JRflImpactSound;

   lifeTimeMS = 150;

   particleEmitter = JRflExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = "JRflExplosionDustEmitter";

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "0.7 0 0";
   lightEndColor = "0 0 0";
};


AddDamageType("JusticeRifle",   '<bitmap:add-ons/Weapon_JusticeRifle/ci_JRnormal> %1',    '%2 <bitmap:add-ons/Weapon_JusticeRifle/ci_JRnormal> %1',0.75,1);
AddDamageType("JusticeRifleHeadshot",   '<bitmap:add-ons/Weapon_JusticeRifle/ci_JRheadshot> %1',    '%2 <bitmap:add-ons/Weapon_JusticeRifle/ci_JRheadshot>%1',0.75,1);
datablock ProjectileData(JRflProjectile)
{
   projectileShapeName = "./JRShell.dts";
   directDamage        = 150;
   directDamageType    = $DamageType::JusticeRifle;
   radiusDamageType    = $DamageType::JusticeRifle;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 20;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 15;  //max volume of bricks that we can destroy if they aren't connected to the ground

   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   impactImpulse	     = 20;
   verticalImpulse	  = 40;
   explosion           = JRflExplosion;
   bloodExplosion      = JRflExplosion;
   particleEmitter     = JRflTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0.0;

   armingDelay         = 00;
   lifetime            = 9999;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod          = 0.4;
   bounceAngle         = 165;
   minStickVelocity    = 10;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.01;   
   uiName = "Justice Rifle Bullet";

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//package JRflPSff
//{
//     function Projectile::onAdd(%obj,%a,%b)
//     {
//        if(%obj.dataBlock.getID() == JRflProjectile.getID())
//        {
//		
//        %obj.initialvelocity=vectorscale(vectorNormalize(%obj.initialvelocity),500);
//        }
//        Parent::onAdd(%obj,%a,%b);
//     }
//};
//ActivatePackage(JRflPSff);

function JRflProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = 20;
   %damage = %directDamage;

   %sobj = %obj.sourceObject;
   if(%sobj.getType() & $TypeMasks::PlayerObjectType)
   {
      if(isObject(%sobj.client))
         %sobj.client.play2d(bulletHitSound);
   }
   
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %colscale = getWord(%col.getScale(),2);
      if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale)
      {
         %directDamage = %directDamage * 6;
         %damageType = $DamageType::JusticeRifleHeadshot;
         
         %col.spawnExplosion(critProjectile,%colscale);
         if(isObject(%col.client))
            %col.client.play2d(critRecieveSound);
         
         if(%sobj.getType() & $TypeMasks::PlayerObjectType)
         {
            serverplay3d(critFireSound,%sobj.getHackPosition());
            if(isObject(%sobj.client))
               %sobj.client.play2d(critHitSound);
         }
      }
      
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
}

//////////
// item //
//////////
datablock ItemData(JRflItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./JusticeRifle.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Justice Rifle";
	iconName = "./JRflIcon";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = JRflImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(JRflImage)
{
   // Basic Item properties
   shapeFile = "./JusticeRifle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.1 -0.55";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = JRflItem;
   ammo = " ";
   projectile = JRflProjectile;
   projectileType = Projectile;

   casing = JRflShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0.03125 -2.7";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 25;

   doColorShift = true;
   colorShiftColor = JRflItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]			  = weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateTimeoutValue[1]		  = 0.01;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		  = true;
	stateEmitter[2]			  = gunFlashEmitter;
	stateEmitterTime[2]		  = 0.05;
	stateEmitterNode[2]		  = "muzzleNode";
	stateSound[2]			  = JRflFireSound;

	stateName[3] 			  = "Smoke";
	stateEmitter[3]			  = JRflSmokeEmitter;
	stateEmitterTime[3]		  = 0.05;
	stateEmitterNode[3]		  = "muzzleNode";
	stateTimeoutValue[3]            = 0.075;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			  = "Reload";
	stateTimeoutValue[4]		  = 0.2;
	stateSequence[4]			  = "reload";
	stateTransitionOnTimeout[4]	  = "Wait";
	stateWaitForTimeout[4]		  = true;
	stateEjectShell[4]       	  = true;
	stateSound[4]			  = JRflReloadSound;
	
	stateName[5]			  = "Wait";
	stateTimeoutValue[5]		  = 0.1;
	stateTransitionOnTimeout[5]	  = "Ready";
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(JRflSCOPEDImage)
{
   // Basic Item properties
   shapeFile = "./JusticeRifleSCOPED.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0 -0.125 -0.425";
   rotation = ""; //eulerToMatrix( "0 0 0" )

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = JRflProjectile;
   projectileType = Projectile;

	casing = JRflShellDebris;
	shellExitDir        = "-1.0 -1.0 -3.0";
	shellExitOffset     = "0 0.03125 -2.7";
	shellExitVariance   = 15.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   LarmReady = true;

   doColorShift = false;
   colorShiftColor = JRflItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state.
   // The animation dustLock is used to reset the bolt to the closed
   // position when you pick it up.
	stateName[0]                    = "Activate";
	stateSequence[0]		= "dustLock";
	stateTimeoutValue[0]            = 0.15;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]			  = weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateTimeoutValue[1]		  = 0.01;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		  = true;
	stateEmitter[2]			  = gunFlashEmitter;
	stateEmitterTime[2]		  = 0.05;
	stateEmitterNode[2]		  = "muzzleNode";
	stateSound[2]			  = JRflFireSound;

	stateName[3] 			  = "Smoke";
	stateEmitter[3]			  = JRflSmokeEmitter;
	stateEmitterTime[3]		  = 0.05;
	stateEmitterNode[3]		  = "muzzleNode";
	stateTimeoutValue[3]            = 0.075;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			  = "Reload";
	stateTimeoutValue[4]		  = 0.2;
	stateSequence[4]			  = "reload";
	stateTransitionOnTimeout[4]	  = "Wait";
	stateWaitForTimeout[4]		  = true;
	stateEjectShell[4]       	  = true;
	stateSound[4]			  = JRflReloadSound;
	
	stateName[5]			  = "Wait";
	stateTimeoutValue[5]		  = 0.1;
	stateTransitionOnTimeout[5]	  = "Ready";
	
};

function JRflImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
	Parent::onFire(%this,%obj,%slot);
}

package imageSwitch
{
	function Armor::onTrigger(%this,%obj,%slot,%val)
	{
		Parent::onTrigger(%this,%obj,%slot,%val);
		if(%slot == 4 && %val)
		{
			if(%obj.getMountedImage(0) == JRflImage.getID())
			{
				%obj.updateArm(JRflSCOPEDImage);
				%obj.mountImage(JRflSCOPEDImage,0);
			}
			else if(%obj.getMountedImage(0) == JRflSCOPEDImage.getID())
			{
				%obj.updateArm(JRflSCOPEDImage);
				%obj.mountImage(JRflImage,0);
			}
		}
	}
};
activatePackage(imageSwitch);